connector = {
    data:function(){
        return {
            context:'',
            post:'POST',
            get:'GET'
        }
    },
    methods:{
        postApi:function(url, args, onSuccess, onError){
            this.doRequest(url, this.post, args, function (a) {
                try {
                    let json = JSON.parse(a);
                    if (typeof onSuccess === "function") {
                        onSuccess(json);
                    }
                } catch (e) {
                    console.log(e);
                    console.log(a);
                }
            }, onError)
        },
        postReq: function (url, args, onSuccess, onError) {
            this.doRequest(url, this.post, args, onSuccess, onError)
        },
        getReq: function (url, args, onSuccess, onError) {
            this.doRequest(url, this.get, args, onSuccess, onError)
        },
        doRequest: function (url, method, args, onSuccess, onError) {
            if (url.substring(0, this.context.length) !== this.context){
                url = this.context + url;
            }
            let XHR = 'onload' in new XMLHttpRequest() ? XMLHttpRequest : XDomainRequest;
            let xhr = new XHR();

            xhr.onload = function () {
                if (xhr.status === 200) {
                    if (onSuccess) {
                        onSuccess(xhr.responseText);
                    }
                } else if (onError){
                    onError(xhr.responseText);
                }
            };
            xhr.open(method, url, true);
            if (method === this.post) {
                xhr.setRequestHeader('Content-type', 'application/json');
            }
            xhr.send(JSON.stringify(args));
        }
    }
};